# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Assay Class
#'
#' Specification of assay. (empty) name: A name for each assay, to serve as a list of the assays that MUST be reported in the following tables.  custom: Additional custom parameters or values for a given assay.  external_uri: An external reference uri to further information about the assay, for example via a reference to an object within an ISA-TAB file.  sample_ref: An association from a given assay to the sample analysed.  ms_run_ref: An association from a given assay to the source MS run. All assays MUST reference exactly one ms_run unless a workflow with pre-fractionation is being encoded, in which case each assay MUST reference n ms_runs where n fractions have been collected. Multiple assays SHOULD reference the same ms_run to capture multiplexed experimental designs.       
#'
#' @field id 
#' @field elementType 
#' @field name 
#' @field custom 
#' @field external_uri 
#' @field sample_ref 
#' @field ms_run_ref 
#'
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Assay <- R6::R6Class(
  'Assay',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `name` = NULL,
    `custom` = NULL,
    `external_uri` = NULL,
    `sample_ref` = NULL,
    `ms_run_ref` = NULL,
    initialize = function(`id`, `elementType`, `name`, `custom`, `external_uri`, `sample_ref`, `ms_run_ref`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!missing(`custom`)) {
        stopifnot(is.list(`custom`), length(`custom`) != 0)
        lapply(`custom`, function(x) stopifnot(R6::is.R6(x)))
        self$`custom` <- `custom`
      }
      if (!missing(`external_uri`)) {
        stopifnot(is.character(`external_uri`), length(`external_uri`) == 1)
        self$`external_uri` <- `external_uri`
      }
      if (!missing(`sample_ref`)) {
        stopifnot(R6::is.R6(`sample_ref`))
        self$`sample_ref` <- `sample_ref`
      }
      if (!missing(`ms_run_ref`)) {
        stopifnot(is.list(`ms_run_ref`), length(`ms_run_ref`) != 0)
        lapply(`ms_run_ref`, function(x) stopifnot(R6::is.R6(x)))
        self$`ms_run_ref` <- `ms_run_ref`
      }
    },
    toJSON = function() {
      AssayObject <- list()
      if (!is.null(self$`id`)) {
        AssayObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        AssayObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`name`)) {
        AssayObject[['name']] <- self$`name`
      }
      if (!is.null(self$`custom`)) {
        AssayObject[['custom']] <- lapply(self$`custom`, function(x) x$toJSON())
      }
      if (!is.null(self$`external_uri`)) {
        AssayObject[['external_uri']] <- self$`external_uri`
      }
      if (!is.null(self$`sample_ref`)) {
        AssayObject[['sample_ref']] <- self$`sample_ref`$toJSON()
      }
      if (!is.null(self$`ms_run_ref`)) {
        AssayObject[['ms_run_ref']] <- lapply(self$`ms_run_ref`, function(x) x$toJSON())
      }

      AssayObject
    },
    fromJSON = function(AssayJson) {
      AssayObject <- jsonlite::fromJSON(AssayJson, simplifyVector = FALSE)
      if (!is.null(AssayObject$`id`)) {
        self$`id` <- AssayObject$`id`
      }
      if (!is.null(AssayObject$`elementType`)) {
        self$`elementType` <- AssayObject$`elementType`
      }
      if (!is.null(AssayObject$`name`)) {
        self$`name` <- AssayObject$`name`
      }
      if (!is.null(AssayObject$`custom`)) {
        self$`custom` <- lapply(AssayObject$`custom`, function(x) {
          `customObject` <- Parameter$new()
          `customObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `customObject`
        })
      }
      if (!is.null(AssayObject$`external_uri`)) {
        self$`external_uri` <- AssayObject$`external_uri`
      }
      if (!is.null(AssayObject$`sample_ref`)) {
        `sample_refObject` <- Sample$new()
        `sample_refObject`$fromJSON(jsonlite::toJSON(AssayObject$sample_ref, auto_unbox = TRUE))
        self$`sample_ref` <- `sample_refObject`
      }
      if (!is.null(AssayObject$`ms_run_ref`)) {
        self$`ms_run_ref` <- lapply(AssayObject$`ms_run_ref`, function(x) {
          `ms_run_refObject` <- MsRun$new()
          `ms_run_refObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `ms_run_refObject`
        })
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "name": %s,
           "custom": [%s],
           "external_uri": %s,
           "sample_ref": %s,
           "ms_run_ref": [%s]
        }',
        self$`id`,
        self$`elementType`,
        self$`name`,
        lapply(self$`custom`, function(x) paste(x$toJSON(), sep=",")),
        self$`external_uri`,
        self$`sample_ref`$toJSON(),
        lapply(self$`ms_run_ref`, function(x) paste(x$toJSON(), sep=","))
      )
    },
    fromJSONString = function(AssayJson) {
      AssayObject <- jsonlite::fromJSON(AssayJson, simplifyVector = FALSE)
      self$`id` <- AssayObject$`id`
      self$`elementType` <- AssayObject$`elementType`
      self$`name` <- AssayObject$`name`
      self$`custom` <- lapply(AssayObject$`custom`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`external_uri` <- AssayObject$`external_uri`
      SampleObject <- Sample$new()
      self$`sample_ref` <- SampleObject$fromJSON(jsonlite::toJSON(AssayObject$sample_ref, auto_unbox = TRUE))
      self$`ms_run_ref` <- lapply(AssayObject$`ms_run_ref`, function(x) MsRun$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
    }
  )
)
